<template>
    <v-container
        class="py-0"
        fluid
    >
        <v-row>
            <v-col class="pa-0">
                <v-text-field
                    class="discount"
                    v-model="localValue"
                    type="number"
                    :error-messages="errors"
                    :placeholder="placeholder"
                    :hide-details="hideDetails"
                    outlined
                >
                </v-text-field>
            </v-col>
            <v-col class="pa-0 col-md-4">
                <v-select
                    class="discount-field"
                    item-value="id"
                    v-model="localType"
                    :items="types"
                    :hide-details="hideDetails"
                    outlined
                >
                    <template slot="selection" slot-scope="data">
                        <span v-if="data.item.id === 1">MYR</span>
                        <v-icon v-else>mdi-percent</v-icon>
                    </template>

                    <template slot="item" slot-scope="data">
                        <span v-if="data.item.id === 1">MYR</span>
                        <v-icon v-else>mdi-percent</v-icon>
                    </template>
                </v-select>
            </v-col>
        </v-row>

        <v-row v-if="showMethod">
            <v-radio-group v-model="localMethod">
                <v-radio
                    v-for="_method in methods"
                    :key="_method.id"
                    :label="$t(_method.name)"
                    :value="_method.id"
                ></v-radio>
            </v-radio-group>
        </v-row>
    </v-container>
</template>

<script>
    import util from "../../mixins/util";

    export default {
        name: "VDiscountInput",

        mixins: [ util ],

        props: {
            value: {
                required: true
            },
            type: {
                type: Number,
                default: 1
            },
            method: {
                type: Number,
                default: 2
            },
            showMethod: {
                type: Boolean,
                default: true,
            },
            errors: [String, Array],
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: 'auto'
            },
            defaultCountry: {
                type: String,
                default: ''
            }
        },

        data: () => ({
            types: [],
            methods: [],
        }),

        computed: {
            localValue: {
                get() {
                    return this.value;
                },

                set(val) {
                    this.$emit('input', val)
                }
            },

            localType: {
                get() {
                    return this.type;
                },

                set(val) {
                    this.$emit('update:type', val)
                }
            },

            localMethod: {
                get() {
                    return this.method;
                },

                set(val) {
                    this.$emit('update:method', val)
                }
            }
        },

        mounted() {
            this.fetchTypes()
                .then(data => {
                    this.types = data;
                });

            if(this.showMethod) {
                this.fetchMethods()
                    .then(data => {
                        this.methods = data;
                    })
            }
        },

        methods: {
            fetchTypes() {
                return new Promise((resolve, reject) => {
                    axios.get('api/discount/types')
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },

            fetchMethods() {
                return new Promise((resolve, reject) => {
                    axios.get('api/discount/methods')
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            }
        }
    }
</script>

<style scoped>
    .discount-field.v-text-field--outlined:not(.v-input--has-state):not(.v-input--is-focused):not(:hover) >>> fieldset {
        border-left: transparent;
    }
    .discount-field.v-text-field--outlined {
        border-radius: 0 4px 4px 0;
    }
    .discount.v-text-field--outlined {
        border-radius: 4px 0 0 4px;
    }
</style>
